# Class ArrayOfDoublesSetOperationBuilder

java.lang.Object
org.apache.datasketches.tuple.arrayofdoubles.ArrayOfDoublesSetOperationBuilder

public class ArrayOfDoublesSetOperationBuilder extends Object
Builds set operations object for tuple sketches of type ArrayOfDoubles.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`DEFAULT_NOMINAL_ENTRIES`
Default Nominal Entries (a.k.a.
`static final int`
`DEFAULT_NUMBER_OF_VALUES`
Default number of values

## Constructor Summary

Constructors
Constructor
Description
`ArrayOfDoublesSetOperationBuilder()`
Creates an instance of the builder with default parameters

## Method Summary

Modifier and Type
Method
Description
`ArrayOfDoublesAnotB`
`buildAnotB()`
Creates an instance of ArrayOfDoublesAnotB based on the current configuration of the builder.
`ArrayOfDoublesIntersection`
`buildIntersection()`
Creates an instance of ArrayOfDoublesIntersection based on the current configuration of the builder.
`ArrayOfDoublesIntersection`
`buildIntersection(MemorySegment dstSeg)`
Creates an instance of ArrayOfDoublesIntersection in the given MemorySegment and based on the current configuration of the builder.
`ArrayOfDoublesUnion`
`buildUnion()`
Creates an instance of ArrayOfDoublesUnion based on the current configuration of the builder.
`ArrayOfDoublesUnion`
`buildUnion(MemorySegment dstSeg)`
Creates an instance of ArrayOfDoublesUnion based on the current configuration of the builder and the given destination MemorySegment.
`ArrayOfDoublesSetOperationBuilder`
`setNominalEntries(int nomEntries)`
This is to set the nominal number of entries.
`ArrayOfDoublesSetOperationBuilder`
`setNumberOfValues(int numValues)`
This is to set the number of double values associated with each key
`ArrayOfDoublesSetOperationBuilder`
`setSeed(long seed)`
Sets the long seed value that is required by the hashing function.

### Methods inherited from class Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### DEFAULT_NOMINAL_ENTRIES

public static final int DEFAULT_NOMINAL_ENTRIES
Default Nominal Entries (a.k.a. K)

See Also:
  - Constant Field Values

### DEFAULT_NUMBER_OF_VALUES

public static final int DEFAULT_NUMBER_OF_VALUES
Default number of values

See Also:
  - Constant Field Values

## Constructor Details

### ArrayOfDoublesSetOperationBuilder

public ArrayOfDoublesSetOperationBuilder()
Creates an instance of the builder with default parameters

## Method Details

### setNominalEntries

public ArrayOfDoublesSetOperationBuilder setNominalEntries(int nomEntries)
This is to set the nominal number of entries.

Parameters:
  `nomEntries` - Nominal number of entries. Forced to the nearest power of 2 greater than given value.
Returns:
  this builder

### setNumberOfValues

public ArrayOfDoublesSetOperationBuilder setNumberOfValues(int numValues)
This is to set the number of double values associated with each key

Parameters:
  `numValues` - number of double values
Returns:
  this builder

### setSeed

public ArrayOfDoublesSetOperationBuilder setSeed(long seed)
Sets the long seed value that is required by the hashing function.

Parameters:
  `seed` - See seed
Returns:
  this builder

### buildUnion

public ArrayOfDoublesUnion buildUnion()
Creates an instance of ArrayOfDoublesUnion based on the current configuration of the builder. The new instance is allocated on the heap.

Returns:
  an instance of ArrayOfDoublesUnion

### buildUnion

public ArrayOfDoublesUnion buildUnion(MemorySegment dstSeg)
Creates an instance of ArrayOfDoublesUnion based on the current configuration of the builder and the given destination MemorySegment.

Parameters:
  `dstSeg` - destination MemorySegment to be used by the sketch
Returns:
  an instance of ArrayOfDoublesUnion

### buildIntersection

public ArrayOfDoublesIntersection buildIntersection()
Creates an instance of ArrayOfDoublesIntersection based on the current configuration of the builder. The new instance is allocated on the heap. The number of nominal entries is not relevant to this, so it is ignored.

Returns:
  an instance of ArrayOfDoublesIntersection

### buildIntersection

public ArrayOfDoublesIntersection buildIntersection(MemorySegment dstSeg)
Creates an instance of ArrayOfDoublesIntersection in the given MemorySegment and based on the current configuration of the builder. The number of nominal entries is not relevant to this, so it is ignored.

Parameters:
  `dstSeg` - destination MemorySegment to be used by the sketch
Returns:
  an instance of ArrayOfDoublesIntersection

### buildAnotB

public ArrayOfDoublesAnotB buildAnotB()
Creates an instance of ArrayOfDoublesAnotB based on the current configuration of the builder. The number of nominal entries is not relevant to this, so it is ignored.

Returns:
  an instance of ArrayOfDoublesAnotB